Attribute VB_Name = "Vegs"
Option Explicit

'
'  V E G E T A B L E S   M A N A G E M E N T
'

Public counter As Long      ' counts the cycles to change from day to night
Public totvegs As Integer           ' total vegs in sim
Public cooldown As Long

' adds vegetables in random positions
Public Sub VegsRepopulate()
  Dim n As node
  Dim r As Integer
  Dim Rx As Long
  Dim Ry As Long
  Dim t As Integer
  cooldown = cooldown + 1
  If cooldown >= SimOpts.RepopCooldown Then
    For t = 1 To SimOpts.RepopAmount
      If Form1.Active Then
        aggiungirob -1, Random(0, SimOpts.FieldWidth), Random(0, SimOpts.FieldHeight)
        totvegs = totvegs + 1
      End If
    Next t
    cooldown = cooldown - SimOpts.RepopCooldown
  End If
End Sub

' gives vegs their energy meal
Public Sub feedvegs(totnrg As Long, totv As Integer)
  Dim n As node
  Dim t As Integer
  Dim tok As Single
  Dim depth As Long
  Dim daymod As Single
  
  Const Constant As Single = 0.00000005859375
  Dim temp As Single
  
  counter = counter + 1
  If counter > SimOpts.CycleLength And SimOpts.DayNight Then
    SimOpts.Daytime = Not SimOpts.Daytime
    counter = 0
    If SimOpts.Daytime Then
      MDIForm1.daypic.Visible = True
      MDIForm1.nightpic.Visible = False
    Else
      MDIForm1.daypic.Visible = False
      MDIForm1.nightpic.Visible = True
    End If
  End If
  
  If SimOpts.Daytime Then daymod = 1 Else daymod = 0
  If SimOpts.DayNight = True And SimOpts.Daytime = False Then Exit Sub
      
  For t = 1 To MaxRobs
    If rob(t).Veg And rob(t).nrg > 0 And rob(t).Exist Then
      If SimOpts.Pondmode Then
        depth = (rob(t).pos.y / 2000) + 1
        If depth < 1 Then depth = 1
        tok = (SimOpts.LightIntensity / depth ^ SimOpts.Gradient) * daymod + 1
      Else
        tok = totnrg
      End If
      
      If tok < 0 Then tok = 0
      
      Select Case SimOpts.VegFeedingMethod
      Case 0 'per veg
        rob(t).nrg = rob(t).nrg + tok * (1 - SimOpts.VegFeedingToBody)
        rob(t).body = rob(t).body + (tok * SimOpts.VegFeedingToBody) / 10
      Case 1 'per kilobody
        rob(t).nrg = rob(t).nrg + tok * (1 - SimOpts.VegFeedingToBody) * rob(t).body / 1000
        rob(t).body = rob(t).body + (tok * (SimOpts.VegFeedingToBody) * rob(t).body / 1000) / 10
      Case 2 'quadratically based on body.  Close to type 0 near 1000 body points, but quickly diverges at about 5K body points
        tok = tok * ((rob(t).body ^ 2 * Constant) + (1 - Constant * 1000 * 1000))
        rob(t).nrg = rob(t).nrg + tok * (1 - SimOpts.VegFeedingToBody)
        rob(t).body = rob(t).body + (tok * SimOpts.VegFeedingToBody) / 10
      End Select
      
      If rob(t).nrg > 32000 Then rob(t).nrg = 32000
      If rob(t).body > 32000 Then rob(t).body = 32000
      rob(t).radius = FindRadius(rob(t).body)
    End If
    Next t
End Sub
Public Sub feedveg2(t As Integer) 'gives veg an additional meal based on waste
  With rob(t)
  If .nrg + (.Waste / 2) < 32000 Then
    .nrg = .nrg + (.Waste / 2)
    .Waste = .Waste - (.Waste / 2)
  End If
  End With
End Sub

' kill vegetables which are too distant from any robot
'currently broken, so it's commented out
Public Sub KillDistVegs(mdist As Long)
  Dim n As node
  Dim t As Integer
  Dim k As Integer
  Dim mdist2 As Long
  Dim dist2 As Long
  Dim currdist2 As Long
  mdist2 = mdist ^ 2
  For t = 1 To MaxRobs
'    If rob(t).Veg And rob(t).Exist Then
'      currdist2 = 10 ^ 8
'      While Abs(nn.xpos - n.xpos) < mdist And Not nn Is rlist.last
'        k = nn.robn
'        If rob(k).Exist And Not rob(k).Veg Then
'          dist2 = (rob(k).pos.x - rob(t).pos.x) ^ 2 + (rob(k).pos.y - rob(t).pos.y) ^ 2
'          If dist2 < currdist2 Then currdist2 = dist2
'        End If
'        Set nn = rlist.nextorder(nn)
'      Wend
'      Set nn = rlist.prevorder(n)
'      While Abs(nn.xpos - n.xpos) < mdist And Not nn Is rlist.head
'        k = nn.robn
'        If Not rob(k).Veg Then
'          dist2 = (rob(k).pos.x - rob(t).pos.x) ^ 2 + (rob(k).pos.y - rob(t).pos.y) ^ 2
'          If dist2 < currdist2 Then currdist2 = dist2
'        End If
'        Set nn = rlist.prevorder(nn)
'      Wend
'      If currdist2 > mdist2 Then KillRobot (t)
'    End If
  Next t
End Sub
